=== docs/requirements.txt ===
Sphinx>=7,<8
breathe==4.35.0
sphinx_rtd_theme==2.0.0
