=== examples/CMakeLists.txt ===
set_directory_properties(PROPERTIES EXCLUDE_FROM_ALL TRUE)

add_subdirectory(gl_viewer)
